From 49cdcbcf379fb23bf869b602fad0ba7c77d28312 Mon Sep 17 00:00:00 2001
From: Pengpeng Dong <dongpengpeng@uniontech.com>
Date: Thu, 5 Aug 2021 13:11:57 +0800
Subject: [PATCH v1] mmdevapi: Implement AEV_GetMasterVolumeLevelScalar and
 AEV_SetMasterVolumeLevelScalar methods.

Implement AEV_GetMasterVolumeLevelScalar and AEV_SetMasterVolumeLevelScalar methods.

Signed-off-by: Pengpeng Dong <dongpengpeng@uniontech.com>
Change-Id: Ic3d57ede3423145435a67df15c296e2aa8a707f7
---
 dlls/mmdevapi/audiovolume.c | 16 ++++++++++++----
 1 file changed, 12 insertions(+), 4 deletions(-)

diff --git a/dlls/mmdevapi/audiovolume.c b/dlls/mmdevapi/audiovolume.c
index 9214980120e..0e2cdfc846c 100644
--- a/dlls/mmdevapi/audiovolume.c
+++ b/dlls/mmdevapi/audiovolume.c
@@ -45,6 +45,8 @@ typedef struct AEVImpl {
     BOOL mute;
 } AEVImpl;
 
+static float g_master_vol = 1.f;
+
 static inline AEVImpl *impl_from_IAudioEndpointVolumeEx(IAudioEndpointVolumeEx *iface)
 {
     return CONTAINING_RECORD(iface, AEVImpl, IAudioEndpointVolumeEx_iface);
@@ -135,8 +137,13 @@ static HRESULT WINAPI AEV_SetMasterVolumeLevel(IAudioEndpointVolumeEx *iface, fl
 static HRESULT WINAPI AEV_SetMasterVolumeLevelScalar(IAudioEndpointVolumeEx *iface, float level, const GUID *ctx)
 {
     TRACE("(%p)->(%f,%s)\n", iface, level, debugstr_guid(ctx));
-    FIXME("stub\n");
-    return E_NOTIMPL;
+
+    if(level < 0.f || level > 1.f)
+        return E_INVALIDARG;
+
+    g_master_vol = level;
+
+    return S_OK;
 }
 
 static HRESULT WINAPI AEV_GetMasterVolumeLevel(IAudioEndpointVolumeEx *iface, float *leveldb)
@@ -156,10 +163,11 @@ static HRESULT WINAPI AEV_GetMasterVolumeLevel(IAudioEndpointVolumeEx *iface, fl
 static HRESULT WINAPI AEV_GetMasterVolumeLevelScalar(IAudioEndpointVolumeEx *iface, float *level)
 {
     TRACE("(%p)->(%p)\n", iface, level);
+
     if (!level)
         return E_POINTER;
-    FIXME("stub\n");
-    *level = 1.0;
+    *level = g_master_vol;
+
     return S_OK;
 }
 
-- 
2.20.1

